unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, OleCtrls, RealAudioObjects_TLB, StdCtrls;

type
    TTimerThread = class(TThread)
    protected
        procedure Kick();
        procedure Execute; override;
    end;

  TMainForm = class(TForm)
    StatusBar: TStatusBar;
    Panel1: TPanel;
    SpacerTop: TPaintBox;
    SpacerBottom: TPaintBox;
    SpacerLeft: TPaintBox;
    SpacerRight: TPaintBox;
    FReal: TRealAudio;
    Panel2: TPanel;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    Label1: TLabel;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FRealClipOpened(Sender: TObject; const shortClipName,
      url: WideString);
    procedure FRealClipClosed(Sender: TObject);
    procedure FRealPresentationClosed(Sender: TObject);
    procedure FRealPresentationOpened(Sender: TObject);
    procedure FRealBuffering(Sender: TObject; lFlags,
      lPercentage: Integer);
  private
    FTimerThread: TTimerThread;
    FCounter: Integer;
    procedure UpdateForm();
    procedure ShowStatus(const S: string; const index: integer);
    procedure ShowDebug(const S: string);
  public
    { Public 錾 }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

const
    INDEX_TIME = 0;

//=============================================================================
//  TTimerThread implementation
//=============================================================================

//-----------------------------------------------------------------------------
procedure TTimerThread.Kick();
begin
    MainForm.UpdateForm();
end;

//-----------------------------------------------------------------------------
procedure TTimerThread.Execute();
begin
    while not Terminated do
    begin
        Synchronize(Kick);
        Sleep(10);
    end;
end;

//=============================================================================
//  TMainForm implementation
//=============================================================================

//-----------------------------------------------------------------------------
//  Xe[^Xo[ɃbZ[W\
procedure TMainForm.ShowStatus(const S: string; const index: integer);
begin
    StatusBar.Panels[index].Text := S;
end;

//-----------------------------------------------------------------------------
//  TMemoɃbZ[W\
procedure TMainForm.ShowDebug(const S: string);
begin
    Memo1.Lines.Add(S);
end;

//-----------------------------------------------------------------------------
//  RXgN^
procedure TMainForm.FormCreate(Sender: TObject);
begin
    FCounter := 0;
    FTimerThread := TTimerThread.Create(False);

    Label1.Caption := 'RealPlayer Ver.' + FReal.GetVersionInfo;
end;

//-----------------------------------------------------------------------------
//  fXgN^
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    FTimerThread.Free();
end;

//-----------------------------------------------------------------------------
//  ^C}[
procedure TMainForm.UpdateForm();
var
    d1, d2: Double;
    s: String;
begin
    //  ݂̃fBAڂ̕bŎĐ
    d1 := FReal.GetLength / 1000;
    //  fBAړ݈̌ʒu擾
    d2 := FReal.GetPosition / 1000;
    //  A
    s := Format('%fb / %fb', [d2, d1]);

    ShowStatus(s, INDEX_TIME);
end;

//-----------------------------------------------------------------------------
procedure TMainForm.FRealPresentationOpened(Sender: TObject);
begin
    ShowDebug('PresentationOpened');
end;

//-----------------------------------------------------------------------------
//  fBAJ(ȁH)
procedure TMainForm.FRealClipOpened(Sender: TObject; const shortClipName,
  url: WideString);
var
    LName: String;
    LWidth: Integer;
    LHeight: Integer;
begin
    ShowDebug('ClipOpened');

    LName := FReal.GetTitle;
    if (LName = '') then
    begin
        LName := ExtractFileName(shortClipName);
    end;

    //  N㏉߂Ă̂Ƃ͂ǂȂ[
    LWidth := FReal.GetClipWidth;
    LHeight := FReal.GetClipHeight;

    Self.Caption := Format('%s %dx%D %s', [Application.Title, LWidth, LHeight, LName]);
end;

//-----------------------------------------------------------------------------
procedure TMainForm.FRealBuffering(Sender: TObject; lFlags,
  lPercentage: Integer);
begin
    ShowDebug(Format('Buffering:%d%%', [lPercentage]));
end;

//-----------------------------------------------------------------------------
procedure TMainForm.FRealClipClosed(Sender: TObject);
begin
    ShowDebug('ClipClosed');
end;

//-----------------------------------------------------------------------------
procedure TMainForm.FRealPresentationClosed(Sender: TObject);
begin
    ShowDebug('PresentationClosed');
end;

//-----------------------------------------------------------------------------
//  eXg
procedure TMainForm.Button1Click(Sender: TObject);
begin
    if (OpenDialog1.Execute()) then
    begin
        FReal.Source := OpenDialog1.FileName;
        FReal.DoPlay();
    end;
end;

end.
